VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "howto_triangle_puzzle"
   ClientHeight    =   3090
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   4680
   LinkTopic       =   "Form1"
   ScaleHeight     =   3090
   ScaleWidth      =   4680
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton cmdFindSolutions 
      Caption         =   "Find Solutions"
      Default         =   -1  'True
      Height          =   375
      Left            =   0
      TabIndex        =   0
      Top             =   0
      Width           =   1335
   End
   Begin VB.Timer tmrChangeSolution 
      Enabled         =   0   'False
      Interval        =   500
      Left            =   1680
      Top             =   360
   End
   Begin VB.CommandButton cmdShowAllSolutions 
      Caption         =   "Show All"
      Enabled         =   0   'False
      Height          =   375
      Left            =   0
      TabIndex        =   3
      Top             =   960
      Width           =   1335
   End
   Begin VB.CommandButton cmdShowSolutions 
      Caption         =   "Show Solutions"
      Enabled         =   0   'False
      Height          =   375
      Left            =   0
      TabIndex        =   1
      Top             =   480
      Width           =   1335
   End
   Begin VB.Label lblNumSolutions 
      AutoSize        =   -1  'True
      Height          =   195
      Left            =   0
      TabIndex        =   2
      Top             =   2880
      Width           =   45
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

' The points.
Private Xs As Collection
Private Ys As Collection

' The solutions.
Private Solutions As Collection

' The solution we should display.
Private CurrentSolution As Integer

' Define the points and solutions.
Private Sub Form_Load()
Dim dy As Single
Dim dx As Single
Dim top_x As Single
Dim top_y As Single

    ScaleMode = vbPixels

    ' Define the points.
    dy = CSng(ScaleHeight / 4)
    dx = CSng(dy / Sqr(3))
    top_x = CSng(ScaleWidth / 2)
    top_y = -dy / 2
    Set Xs = New Collection
    Set Ys = New Collection
    Xs.Add (top_x - dx): Ys.Add (top_y + dy)
    Xs.Add (top_x + dx): Ys.Add (top_y + dy)
    Xs.Add (top_x - 2 * dx): Ys.Add (top_y + 2 * dy)
    Xs.Add (top_x - 0 * dx): Ys.Add (top_y + 2 * dy)
    Xs.Add (top_x + 2 * dx): Ys.Add (top_y + 2 * dy)
    Xs.Add (top_x - 3 * dx): Ys.Add (top_y + 3 * dy)
    Xs.Add (top_x - 1 * dx): Ys.Add (top_y + 3 * dy)
    Xs.Add (top_x + 1 * dx): Ys.Add (top_y + 3 * dy)
    Xs.Add (top_x + 3 * dx): Ys.Add (top_y + 3 * dy)
    Xs.Add (top_x - 2 * dx): Ys.Add (top_y + 4 * dy)
    Xs.Add (top_x - 0 * dx): Ys.Add (top_y + 4 * dy)
    Xs.Add (top_x + 2 * dx): Ys.Add (top_y + 4 * dy)

    ' Define the solutions.
    Set Solutions = New Collection
    
    ' Start displaying no solution.
    CurrentSolution = Solutions.Count + 1
    lblNumSolutions.Caption = Solutions.Count & " solutions"
End Sub

' Find the solutions.
Private Sub cmdFindSolutions_Click()
Const tiny As Double = 0.0001

Dim i As Integer
Dim j As Integer
Dim k As Integer
Dim dx_ij As Double
Dim dy_ij As Double
Dim dist_ij As Double
Dim dx_jk As Double
Dim dy_jk As Double
Dim dist_jk As Double
Dim dx_ki As Double
Dim dy_ki As Double
Dim dist_ki As Double

    Set Solutions = New Collection
    For i = 1 To Xs.Count
        For j = i + 1 To Xs.Count
            dx_ij = Xs(j) - Xs(i)
            dy_ij = Ys(j) - Ys(i)
            dist_ij = Sqr(dx_ij * dx_ij + dy_ij * dy_ij)
            For k = j + 1 To Xs.Count
                dx_jk = Xs(k) - Xs(j)
                dy_jk = Ys(k) - Ys(j)
                dist_jk = Sqr(dx_jk * dx_jk + dy_jk * dy_jk)
                If (Math.Abs(dist_ij - dist_jk) < tiny) Then
                    dx_ki = Xs(i) - Xs(k)
                    dy_ki = Ys(i) - Ys(k)
                    dist_ki = Sqr(dx_ki * dx_ki + dy_ki * dy_ki)
                    If (Math.Abs(dist_jk - dist_ki) < tiny) Then
                        ' This is a solution.
                        AddSolution i, j, k
                    End If
                End If
            Next k
        Next j
    Next i

    lblNumSolutions.Caption = Solutions.Count & " solutions"
    cmdFindSolutions.Enabled = False
    cmdShowSolutions.Enabled = True
    cmdShowAllSolutions.Enabled = True
    CurrentSolution = Solutions.Count + 1
    Refresh
End Sub

' Add a new solution.
Private Sub AddSolution(ParamArray indices() As Variant)
Dim new_solution As Collection
Dim i As Integer

    ' Create the new solution collection.
    Set new_solution = New Collection
    For i = LBound(indices) To UBound(indices)
        new_solution.Add indices(i)
    Next i
    
    ' Add the new solution to the solutions list.
    Solutions.Add new_solution
End Sub

' Draw the circles and any triangles currently defined.
Private Sub Form_Paint()
Const radius As Single = 5

Dim i As Integer

    ' Draw the points.
    Me.FillStyle = vbFSSolid
    Me.FillColor = vbBlue
    For i = 1 To Xs.Count
        Me.Circle (Xs(i), Ys(i)), radius, vbBlue
    Next i

    ' Draw the current solution.
    If (CurrentSolution < 1) Then
        ' Draw all solutions.
        For i = 1 To Solutions.Count
            DrawSolution i
        Next i
    Else
        ' Draw the current solution.
        DrawSolution CurrentSolution
    End If
End Sub

' Draw a solution.
Private Sub DrawSolution(ByVal solution_num As Integer)
Dim solution As Collection
Dim i As Integer

    If (solution_num > Solutions.Count) Then Exit Sub

    ' Draw this solution.
    Set solution = Solutions(solution_num)
    
    ' Start at the last point.
    Me.CurrentX = Xs(solution(solution.Count))
    Me.CurrentY = Ys(solution(solution.Count))
    
    ' Connect to the other points.
    For i = 1 To solution.Count
        Me.Line -(Xs(solution(i)), Ys(solution(i))), vbRed
    Next i
End Sub

' Start showing solutions.
Private Sub cmdShowSolutions_Click()
    ' Disable the button.
    cmdShowSolutions.Enabled = False

    ' Start at the first solution.
    CurrentSolution = 1

    ' Start the timer.
    tmrChangeSolution.Enabled = True

    ' Redraw.
    Refresh
End Sub

' Show the next solution.
Private Sub tmrChangeSolution_Timer()
    ' Increment CurrentSolution. If the result is greater than the
    ' last solution's index, disable the timer.
    CurrentSolution = CurrentSolution + 1
    tmrChangeSolution.Enabled = (CurrentSolution <= Solutions.Count)

    ' If we're done drawing, enable the button.
    cmdShowSolutions.Enabled = (Not tmrChangeSolution.Enabled)

    ' Redraw.
    Refresh
End Sub

' Show all of the solutions.
Private Sub cmdShowAllSolutions_Click()
    CurrentSolution = 0
    tmrChangeSolution.Enabled = False
    cmdShowSolutions.Enabled = True
    Refresh
End Sub

